-- Copyright 1986-2018 Xilinx, Inc. All Rights Reserved.
-- --------------------------------------------------------------------------------
-- Tool Version: Vivado v.2018.3 (win64) Build 2405991 Thu Dec  6 23:38:27 MST 2018
-- Date        : Tue Dec  8 12:59:58 2020
-- Host        : 740-30 running 64-bit major release  (build 9200)
-- Command     : write_vhdl -mode funcsim -nolib -force -file
--               E:/Spartan7/SRAM_CTRL_Univ01/SRAM_CTRL_Univ01.sim/sim_1/impl/func/xsim/ram_ctrl_test_func_impl.vhd
-- Design      : sram_ctrl
-- Purpose     : This VHDL netlist is a functional simulation representation of the design and should not be modified or
--               synthesized. This netlist cannot be used for SDF annotated simulation.
-- Device      : xc7s15ftgb196-1
-- --------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
entity sram_ctrl is
  port (
    clk : in STD_LOGIC;
    reset : in STD_LOGIC;
    mem : in STD_LOGIC;
    rw : in STD_LOGIC;
    addr : in STD_LOGIC_VECTOR ( 18 downto 0 );
    data_f2s : in STD_LOGIC_VECTOR ( 7 downto 0 );
    ready : out STD_LOGIC;
    data_s2f_r : out STD_LOGIC_VECTOR ( 7 downto 0 );
    data_s2f_ur : out STD_LOGIC_VECTOR ( 7 downto 0 );
    ad : out STD_LOGIC_VECTOR ( 18 downto 0 );
    we_n : out STD_LOGIC;
    oe_n : out STD_LOGIC;
    dio : inout STD_LOGIC_VECTOR ( 7 downto 0 );
    ce_n : out STD_LOGIC
  );
  attribute NotValidForBitStream : boolean;
  attribute NotValidForBitStream of sram_ctrl : entity is true;
  attribute ECO_CHECKSUM : string;
  attribute ECO_CHECKSUM of sram_ctrl : entity is "e96ce857";
end sram_ctrl;

architecture STRUCTURE of sram_ctrl is
  signal \FSM_onehot_state_reg[0]_i_1_n_0\ : STD_LOGIC;
  signal \FSM_onehot_state_reg[3]_i_1_n_0\ : STD_LOGIC;
  signal \FSM_onehot_state_reg_reg_n_0_[1]\ : STD_LOGIC;
  signal \FSM_onehot_state_reg_reg_n_0_[2]\ : STD_LOGIC;
  signal \FSM_onehot_state_reg_reg_n_0_[3]\ : STD_LOGIC;
  signal ad_OBUF : STD_LOGIC_VECTOR ( 18 downto 0 );
  signal addr_IBUF : STD_LOGIC_VECTOR ( 18 downto 0 );
  signal addr_next : STD_LOGIC;
  signal clk_IBUF : STD_LOGIC;
  signal clk_IBUF_BUFG : STD_LOGIC;
  signal data_f2s_IBUF : STD_LOGIC_VECTOR ( 7 downto 0 );
  signal data_f2s_next : STD_LOGIC;
  signal data_s2f_next : STD_LOGIC;
  signal data_s2f_r_OBUF : STD_LOGIC_VECTOR ( 7 downto 0 );
  signal dio_IBUF : STD_LOGIC_VECTOR ( 7 downto 0 );
  signal dio_OBUF : STD_LOGIC_VECTOR ( 7 downto 0 );
  signal \dio_TRI[0]\ : STD_LOGIC;
  signal mem_IBUF : STD_LOGIC;
  signal oe_n_OBUF : STD_LOGIC;
  signal oe_reg_i_1_n_0 : STD_LOGIC;
  signal ready_OBUF : STD_LOGIC;
  signal reset_IBUF : STD_LOGIC;
  signal rw_IBUF : STD_LOGIC;
  signal tri_reg_inv_i_1_n_0 : STD_LOGIC;
  signal we_buf : STD_LOGIC;
  signal we_n_OBUF : STD_LOGIC;
  attribute FSM_ENCODED_STATES : string;
  attribute FSM_ENCODED_STATES of \FSM_onehot_state_reg_reg[0]\ : label is "w2:00100,r2:10000,idle:00001,r1:01000,w1:00010";
  attribute FSM_ENCODED_STATES of \FSM_onehot_state_reg_reg[1]\ : label is "w2:00100,r2:10000,idle:00001,r1:01000,w1:00010";
  attribute FSM_ENCODED_STATES of \FSM_onehot_state_reg_reg[2]\ : label is "w2:00100,r2:10000,idle:00001,r1:01000,w1:00010";
  attribute FSM_ENCODED_STATES of \FSM_onehot_state_reg_reg[3]\ : label is "w2:00100,r2:10000,idle:00001,r1:01000,w1:00010";
  attribute FSM_ENCODED_STATES of \FSM_onehot_state_reg_reg[4]\ : label is "w2:00100,r2:10000,idle:00001,r1:01000,w1:00010";
  attribute OPT_MODIFIED : string;
  attribute OPT_MODIFIED of tri_reg_inv_i_2 : label is "RETARGET ";
  attribute SOFT_HLUTNM : string;
  attribute SOFT_HLUTNM of tri_reg_inv_i_2 : label is "soft_lutpair0";
  attribute SOFT_HLUTNM of we_reg_i_1 : label is "soft_lutpair0";
begin
\FSM_onehot_state_reg[0]_i_1\: unisim.vcomponents.LUT4
    generic map(
      INIT => X"FFAE"
    )
        port map (
      I0 => data_s2f_next,
      I1 => ready_OBUF,
      I2 => mem_IBUF,
      I3 => \FSM_onehot_state_reg_reg_n_0_[2]\,
      O => \FSM_onehot_state_reg[0]_i_1_n_0\
    );
\FSM_onehot_state_reg[1]_i_1\: unisim.vcomponents.LUT3
    generic map(
      INIT => X"20"
    )
        port map (
      I0 => ready_OBUF,
      I1 => rw_IBUF,
      I2 => mem_IBUF,
      O => data_f2s_next
    );
\FSM_onehot_state_reg[3]_i_1\: unisim.vcomponents.LUT3
    generic map(
      INIT => X"80"
    )
        port map (
      I0 => ready_OBUF,
      I1 => rw_IBUF,
      I2 => mem_IBUF,
      O => \FSM_onehot_state_reg[3]_i_1_n_0\
    );
\FSM_onehot_state_reg_reg[0]\: unisim.vcomponents.FDPE
    generic map(
      INIT => '1'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      D => \FSM_onehot_state_reg[0]_i_1_n_0\,
      PRE => reset_IBUF,
      Q => ready_OBUF
    );
\FSM_onehot_state_reg_reg[1]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      CLR => reset_IBUF,
      D => data_f2s_next,
      Q => \FSM_onehot_state_reg_reg_n_0_[1]\
    );
\FSM_onehot_state_reg_reg[2]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      CLR => reset_IBUF,
      D => \FSM_onehot_state_reg_reg_n_0_[1]\,
      Q => \FSM_onehot_state_reg_reg_n_0_[2]\
    );
\FSM_onehot_state_reg_reg[3]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      CLR => reset_IBUF,
      D => \FSM_onehot_state_reg[3]_i_1_n_0\,
      Q => \FSM_onehot_state_reg_reg_n_0_[3]\
    );
\FSM_onehot_state_reg_reg[4]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      CLR => reset_IBUF,
      D => \FSM_onehot_state_reg_reg_n_0_[3]\,
      Q => data_s2f_next
    );
\ad_OBUF[0]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(0),
      O => ad(0)
    );
\ad_OBUF[10]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(10),
      O => ad(10)
    );
\ad_OBUF[11]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(11),
      O => ad(11)
    );
\ad_OBUF[12]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(12),
      O => ad(12)
    );
\ad_OBUF[13]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(13),
      O => ad(13)
    );
\ad_OBUF[14]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(14),
      O => ad(14)
    );
\ad_OBUF[15]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(15),
      O => ad(15)
    );
\ad_OBUF[16]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(16),
      O => ad(16)
    );
\ad_OBUF[17]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(17),
      O => ad(17)
    );
\ad_OBUF[18]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(18),
      O => ad(18)
    );
\ad_OBUF[1]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(1),
      O => ad(1)
    );
\ad_OBUF[2]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(2),
      O => ad(2)
    );
\ad_OBUF[3]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(3),
      O => ad(3)
    );
\ad_OBUF[4]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(4),
      O => ad(4)
    );
\ad_OBUF[5]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(5),
      O => ad(5)
    );
\ad_OBUF[6]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(6),
      O => ad(6)
    );
\ad_OBUF[7]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(7),
      O => ad(7)
    );
\ad_OBUF[8]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(8),
      O => ad(8)
    );
\ad_OBUF[9]_inst\: unisim.vcomponents.OBUF
     port map (
      I => ad_OBUF(9),
      O => ad(9)
    );
\addr_IBUF[0]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(0),
      O => addr_IBUF(0)
    );
\addr_IBUF[10]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(10),
      O => addr_IBUF(10)
    );
\addr_IBUF[11]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(11),
      O => addr_IBUF(11)
    );
\addr_IBUF[12]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(12),
      O => addr_IBUF(12)
    );
\addr_IBUF[13]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(13),
      O => addr_IBUF(13)
    );
\addr_IBUF[14]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(14),
      O => addr_IBUF(14)
    );
\addr_IBUF[15]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(15),
      O => addr_IBUF(15)
    );
\addr_IBUF[16]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(16),
      O => addr_IBUF(16)
    );
\addr_IBUF[17]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(17),
      O => addr_IBUF(17)
    );
\addr_IBUF[18]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(18),
      O => addr_IBUF(18)
    );
\addr_IBUF[1]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(1),
      O => addr_IBUF(1)
    );
\addr_IBUF[2]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(2),
      O => addr_IBUF(2)
    );
\addr_IBUF[3]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(3),
      O => addr_IBUF(3)
    );
\addr_IBUF[4]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(4),
      O => addr_IBUF(4)
    );
\addr_IBUF[5]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(5),
      O => addr_IBUF(5)
    );
\addr_IBUF[6]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(6),
      O => addr_IBUF(6)
    );
\addr_IBUF[7]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(7),
      O => addr_IBUF(7)
    );
\addr_IBUF[8]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(8),
      O => addr_IBUF(8)
    );
\addr_IBUF[9]_inst\: unisim.vcomponents.IBUF
     port map (
      I => addr(9),
      O => addr_IBUF(9)
    );
\addr_reg[18]_i_1\: unisim.vcomponents.LUT2
    generic map(
      INIT => X"8"
    )
        port map (
      I0 => ready_OBUF,
      I1 => mem_IBUF,
      O => addr_next
    );
\addr_reg_reg[0]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(0),
      Q => ad_OBUF(0)
    );
\addr_reg_reg[10]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(10),
      Q => ad_OBUF(10)
    );
\addr_reg_reg[11]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(11),
      Q => ad_OBUF(11)
    );
\addr_reg_reg[12]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(12),
      Q => ad_OBUF(12)
    );
\addr_reg_reg[13]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(13),
      Q => ad_OBUF(13)
    );
\addr_reg_reg[14]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(14),
      Q => ad_OBUF(14)
    );
\addr_reg_reg[15]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(15),
      Q => ad_OBUF(15)
    );
\addr_reg_reg[16]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(16),
      Q => ad_OBUF(16)
    );
\addr_reg_reg[17]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(17),
      Q => ad_OBUF(17)
    );
\addr_reg_reg[18]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(18),
      Q => ad_OBUF(18)
    );
\addr_reg_reg[1]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(1),
      Q => ad_OBUF(1)
    );
\addr_reg_reg[2]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(2),
      Q => ad_OBUF(2)
    );
\addr_reg_reg[3]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(3),
      Q => ad_OBUF(3)
    );
\addr_reg_reg[4]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(4),
      Q => ad_OBUF(4)
    );
\addr_reg_reg[5]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(5),
      Q => ad_OBUF(5)
    );
\addr_reg_reg[6]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(6),
      Q => ad_OBUF(6)
    );
\addr_reg_reg[7]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(7),
      Q => ad_OBUF(7)
    );
\addr_reg_reg[8]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(8),
      Q => ad_OBUF(8)
    );
\addr_reg_reg[9]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => addr_next,
      CLR => reset_IBUF,
      D => addr_IBUF(9),
      Q => ad_OBUF(9)
    );
ce_n_OBUF_inst: unisim.vcomponents.OBUF
     port map (
      I => '0',
      O => ce_n
    );
clk_IBUF_BUFG_inst: unisim.vcomponents.BUFG
     port map (
      I => clk_IBUF,
      O => clk_IBUF_BUFG
    );
clk_IBUF_inst: unisim.vcomponents.IBUF
     port map (
      I => clk,
      O => clk_IBUF
    );
\data_f2s_IBUF[0]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(0),
      O => data_f2s_IBUF(0)
    );
\data_f2s_IBUF[1]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(1),
      O => data_f2s_IBUF(1)
    );
\data_f2s_IBUF[2]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(2),
      O => data_f2s_IBUF(2)
    );
\data_f2s_IBUF[3]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(3),
      O => data_f2s_IBUF(3)
    );
\data_f2s_IBUF[4]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(4),
      O => data_f2s_IBUF(4)
    );
\data_f2s_IBUF[5]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(5),
      O => data_f2s_IBUF(5)
    );
\data_f2s_IBUF[6]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(6),
      O => data_f2s_IBUF(6)
    );
\data_f2s_IBUF[7]_inst\: unisim.vcomponents.IBUF
     port map (
      I => data_f2s(7),
      O => data_f2s_IBUF(7)
    );
\data_f2s_reg_reg[0]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(0),
      Q => dio_OBUF(0)
    );
\data_f2s_reg_reg[1]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(1),
      Q => dio_OBUF(1)
    );
\data_f2s_reg_reg[2]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(2),
      Q => dio_OBUF(2)
    );
\data_f2s_reg_reg[3]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(3),
      Q => dio_OBUF(3)
    );
\data_f2s_reg_reg[4]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(4),
      Q => dio_OBUF(4)
    );
\data_f2s_reg_reg[5]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(5),
      Q => dio_OBUF(5)
    );
\data_f2s_reg_reg[6]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(6),
      Q => dio_OBUF(6)
    );
\data_f2s_reg_reg[7]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_f2s_next,
      CLR => reset_IBUF,
      D => data_f2s_IBUF(7),
      Q => dio_OBUF(7)
    );
\data_s2f_r_OBUF[0]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(0),
      O => data_s2f_r(0)
    );
\data_s2f_r_OBUF[1]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(1),
      O => data_s2f_r(1)
    );
\data_s2f_r_OBUF[2]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(2),
      O => data_s2f_r(2)
    );
\data_s2f_r_OBUF[3]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(3),
      O => data_s2f_r(3)
    );
\data_s2f_r_OBUF[4]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(4),
      O => data_s2f_r(4)
    );
\data_s2f_r_OBUF[5]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(5),
      O => data_s2f_r(5)
    );
\data_s2f_r_OBUF[6]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(6),
      O => data_s2f_r(6)
    );
\data_s2f_r_OBUF[7]_inst\: unisim.vcomponents.OBUF
     port map (
      I => data_s2f_r_OBUF(7),
      O => data_s2f_r(7)
    );
\data_s2f_reg_reg[0]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(0),
      Q => data_s2f_r_OBUF(0)
    );
\data_s2f_reg_reg[1]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(1),
      Q => data_s2f_r_OBUF(1)
    );
\data_s2f_reg_reg[2]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(2),
      Q => data_s2f_r_OBUF(2)
    );
\data_s2f_reg_reg[3]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(3),
      Q => data_s2f_r_OBUF(3)
    );
\data_s2f_reg_reg[4]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(4),
      Q => data_s2f_r_OBUF(4)
    );
\data_s2f_reg_reg[5]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(5),
      Q => data_s2f_r_OBUF(5)
    );
\data_s2f_reg_reg[6]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(6),
      Q => data_s2f_r_OBUF(6)
    );
\data_s2f_reg_reg[7]\: unisim.vcomponents.FDCE
    generic map(
      INIT => '0'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => data_s2f_next,
      CLR => reset_IBUF,
      D => dio_IBUF(7),
      Q => data_s2f_r_OBUF(7)
    );
\data_s2f_ur_OBUF[0]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(0),
      O => data_s2f_ur(0)
    );
\data_s2f_ur_OBUF[1]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(1),
      O => data_s2f_ur(1)
    );
\data_s2f_ur_OBUF[2]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(2),
      O => data_s2f_ur(2)
    );
\data_s2f_ur_OBUF[3]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(3),
      O => data_s2f_ur(3)
    );
\data_s2f_ur_OBUF[4]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(4),
      O => data_s2f_ur(4)
    );
\data_s2f_ur_OBUF[5]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(5),
      O => data_s2f_ur(5)
    );
\data_s2f_ur_OBUF[6]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(6),
      O => data_s2f_ur(6)
    );
\data_s2f_ur_OBUF[7]_inst\: unisim.vcomponents.OBUF
     port map (
      I => dio_IBUF(7),
      O => data_s2f_ur(7)
    );
\dio_IOBUF[0]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(0),
      IO => dio(0),
      O => dio_IBUF(0),
      T => \dio_TRI[0]\
    );
\dio_IOBUF[1]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(1),
      IO => dio(1),
      O => dio_IBUF(1),
      T => \dio_TRI[0]\
    );
\dio_IOBUF[2]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(2),
      IO => dio(2),
      O => dio_IBUF(2),
      T => \dio_TRI[0]\
    );
\dio_IOBUF[3]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(3),
      IO => dio(3),
      O => dio_IBUF(3),
      T => \dio_TRI[0]\
    );
\dio_IOBUF[4]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(4),
      IO => dio(4),
      O => dio_IBUF(4),
      T => \dio_TRI[0]\
    );
\dio_IOBUF[5]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(5),
      IO => dio(5),
      O => dio_IBUF(5),
      T => \dio_TRI[0]\
    );
\dio_IOBUF[6]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(6),
      IO => dio(6),
      O => dio_IBUF(6),
      T => \dio_TRI[0]\
    );
\dio_IOBUF[7]_inst\: unisim.vcomponents.IOBUF
     port map (
      I => dio_OBUF(7),
      IO => dio(7),
      O => dio_IBUF(7),
      T => \dio_TRI[0]\
    );
mem_IBUF_inst: unisim.vcomponents.IBUF
     port map (
      I => mem,
      O => mem_IBUF
    );
oe_n_OBUF_inst: unisim.vcomponents.OBUF
     port map (
      I => oe_n_OBUF,
      O => oe_n
    );
oe_reg_i_1: unisim.vcomponents.LUT4
    generic map(
      INIT => X"A07F"
    )
        port map (
      I0 => ready_OBUF,
      I1 => rw_IBUF,
      I2 => mem_IBUF,
      I3 => \FSM_onehot_state_reg_reg_n_0_[3]\,
      O => oe_reg_i_1_n_0
    );
oe_reg_reg: unisim.vcomponents.FDPE
    generic map(
      INIT => '1'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      D => oe_reg_i_1_n_0,
      PRE => reset_IBUF,
      Q => oe_n_OBUF
    );
ready_OBUF_inst: unisim.vcomponents.OBUF
     port map (
      I => ready_OBUF,
      O => ready
    );
reset_IBUF_inst: unisim.vcomponents.IBUF
     port map (
      I => reset,
      O => reset_IBUF
    );
rw_IBUF_inst: unisim.vcomponents.IBUF
     port map (
      I => rw,
      O => rw_IBUF
    );
tri_reg_inv_i_2: unisim.vcomponents.LUT5
    generic map(
      INIT => X"00007F77"
    )
        port map (
      I0 => ready_OBUF,
      I1 => mem_IBUF,
      I2 => \FSM_onehot_state_reg_reg_n_0_[3]\,
      I3 => rw_IBUF,
      I4 => \FSM_onehot_state_reg_reg_n_0_[1]\,
      O => tri_reg_inv_i_1_n_0
    );
tri_reg_reg_inv: unisim.vcomponents.FDPE
    generic map(
      INIT => '1'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      D => tri_reg_inv_i_1_n_0,
      PRE => reset_IBUF,
      Q => \dio_TRI[0]\
    );
we_n_OBUF_inst: unisim.vcomponents.OBUF
     port map (
      I => we_n_OBUF,
      O => we_n
    );
we_reg_i_1: unisim.vcomponents.LUT4
    generic map(
      INIT => X"2FFF"
    )
        port map (
      I0 => rw_IBUF,
      I1 => \FSM_onehot_state_reg_reg_n_0_[3]\,
      I2 => mem_IBUF,
      I3 => ready_OBUF,
      O => we_buf
    );
we_reg_reg: unisim.vcomponents.FDPE
    generic map(
      INIT => '1'
    )
        port map (
      C => clk_IBUF_BUFG,
      CE => '1',
      D => we_buf,
      PRE => reset_IBUF,
      Q => we_n_OBUF
    );
end STRUCTURE;
